{% extends 'base.html.twig' %}

{% block stylesheets %}
    {{ parent() }}
    {{ encore_entry_link_tags('company_location_management/matching/object_detail') }}
{% endblock %}

{% block javascripts %}
    {{ parent() }}
    {{ encore_entry_script_tags('company_location_management/matching/object_detail') }}
{% endblock %}

{% block mainHeader %}
    <div class="container-fluid d-flex bg-white justify-content-start px-4 py-4">
        <a href="{{ path('company_location_management_matching_object_overview', fetch_merged_url_parameters_by_session_key_name('matchingOverview')) }}" class="me-2 d-flex align-items-center text-decoration-none"><i class="material-icons md-36">arrow_back</i></a>
        <span class="text-primary fs-5 align-self-center">Matching-Ergebnisse, {{ buildingUnit.getName() }} </span>
        {% if is_granted('ROLE_USER') == true %}
            <a href="{{ path('company_location_management_matching_object_matching_task_create', {'id': buildingUnit.getId()}) }}" class="mdc-button mdc-button--raised mdc-button--leading ms-auto align-self-center">
                <span class='material-icons-outlined mx-2'>cached</span>
                <span class="mdc-button__label d-md-none">Matching</span>
                <span class="mdc-button__label d-none d-md-block">Neues Matching starten</span>
            </a>
        {% endif %}
    </div>
{% endblock %}

{% block main %}
    {% set sumOfResults = 0 %}
    <div class="container-lg mt-4">
        <div class="mb-4">
            {% include 'company_location_management/component/matching/object_detail_card_component.html.twig' with {'buildingUnit': buildingUnit} only %}
        </div>
        <div class="mdc-card mb-4 p-4 text-center">
            {% set matchingTask = buildingUnit.getMatchingTask() %}
            {% set settlementConceptMatchingTask = buildingUnit.getSettlementConceptMatchingTask() %}

            {% if
                (matchingTask == null or settlementConceptMatchingTask == null)
                or (
                    (matchingTask != null and matchingTask.getTaskStatus().name == 'FAILED')
                    or (settlementConceptMatchingTask != null and settlementConceptMatchingTask.getTaskStatus().name == 'FAILED')
                )
            %}
                <p class="mb-0">Für dieses Objekt wurde bislang kein Matching ausgeführt. Sie können das Matching oben rechts starten.</p>
            {% else %}
                {% if
                    (matchingTask != null and (matchingTask.getTaskStatus().name == 'CREATED' or matchingTask.getTaskStatus().name == 'IN_PROGRESS'))
                    or (settlementConceptMatchingTask != null and (settlementConceptMatchingTask.getTaskStatus().name == 'CREATED' or settlementConceptMatchingTask.getTaskStatus().name == 'IN_PROGRESS'))
                %}
                    <p class="mb-0">Für dieses Objekt läuft das Matching derzeit noch. Bitte rufen Sie die Seite in Kürze erneut auf.</p>
                {% elseif (matchingTask != null and matchingTask.getTaskStatus().name == 'DONE') or (settlementConceptMatchingTask != null and settlementConceptMatchingTask.getTaskStatus().name == 'DONE') %}
                    <p class="mb-0">Das letzte Matching wurde am {{ matchingTask.getUpdatedAt().format('d.m.Y') }} um {{ matchingTask.getUpdatedAt().format('H:i') }} Uhr ausgeführt.</p>
                    {% set sumOfResults = buildingUnit.getMatchingResults()|length + buildingUnit.getSettlementConceptMatchingResults()|length %}

                    {% if sumOfResults != 0 %}
                        <p class="mt-3 mb-0">Im <a href="#" class="text-decoration-none" data-coreui-toggle="modal" data-coreui-target="#global-matching-information"><strong>Möglichkeitenraum</strong> <i class="material-icons small">help_outline</i></a> befinden sich derzeit <strong>{{ sumOfResults }}</strong> Optionen.</p>
                    {% endif %}
                {% endif %}
            {% endif %}
        </div>
        <div class="mdc-card mb-4">
            {% include 'component/mdc_tab_bar_component.html.twig' with {
                'id': 'matching_result_tab_bar',
                'tabs': [
                    {'name': 'Ansiedlungsgesuche (' ~ buildingUnit.getMatchingResults()|length ~ ')', 'description': '– bei uns eingegangen –', 'id': 'looking_for_property_request_tab', 'active': activeLookingForPropertyRequest},
                    {'name': 'Ansiedlungskonzepte (' ~ buildingUnit.getSettlementConceptMatchingResults()|length ~ ')', 'description': '– aus externer Datenbank –', 'id': 'settlement_concept_tab', 'active': activeSettlementConcept},
                ]
            } only %}
            {% include 'company_location_management/component/matching/looking_for_property_request_matching_list_component.html.twig' with {
                'idPrefix': 'looking_for_property_request_matching_',
                'listItems': buildingUnit.getMatchingResults(),
                'massOperation': false,
                'pagination': false,
                'sortable': false,
                'show': activeLookingForPropertyRequest
            } only %}
            {% include 'company_location_management/component/matching/settlement_concept_matching_list_component.html.twig' with {
                'idPrefix': 'settlement_concept_matching_',
                'listItems': buildingUnit.getSettlementConceptMatchingResults(),
                'massOperation': false,
                'pagination': false,
                'sortable': false,
                'show': activeSettlementConcept
            } only %}
        </div>
    </div>

    {% for matchingResult in buildingUnit.getMatchingResults() %}
        {% include 'company_location_management/component/matching/looking_for_property_request_matching_result_modal_component.html.twig' with {
            'matchingResult': matchingResult
        } only %}
    {% endfor %}

    {% for settlementConceptmatchingResult in buildingUnit.getSettlementConceptMatchingResults() %}
        {% include 'company_location_management/component/matching/settlement_concept_matching_result_modal_component.html.twig' with {
            'matchingResult': settlementConceptmatchingResult
        } only %}
    {% endfor %}

    {% if sumOfResults != 0 %}
        {% include 'company_location_management/component/matching/global_matching_information_modal_component.html.twig' only %}
    {% endif %}
{% endblock %}
